"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Pedigree(ProtocolElement):
    """
    This is the concept of a family with associated phenotypes as present
    in the record RDParticipant
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "familyId",
        "members",
        "readyForAnalysis",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import participant as participant_1_5_0

        return {
            "analysisPanels": participant_1_5_0.AnalysisPanel,
            "diseasePenetrances": participant_1_5_0.DiseasePenetrance,
            "members": participant_1_5_0.PedigreeMember,
            "versionControl": participant_1_5_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import participant as participant_1_5_0

        return {
            "familyQCState": participant_1_5_0.FamilyQCState,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.AnalysisPanel": participant_1_5_0.AnalysisPanel,
            "org.gel.models.participant.avro.DiseasePenetrance": participant_1_5_0.DiseasePenetrance,
            "org.gel.models.participant.avro.FamilyQCState": participant_1_5_0.FamilyQCState,
            "org.gel.models.participant.avro.PedigreeMember": participant_1_5_0.PedigreeMember,
            "org.gel.models.participant.avro.VersionControl": participant_1_5_0.VersionControl,
            "org.gel.models.participant.avro.Pedigree": participant_1_5_0.Pedigree,
        }

    __slots__ = [
        "familyId",
        "members",
        "readyForAnalysis",
        "LDPCode",
        "analysisPanels",
        "diseasePenetrances",
        "familyQCState",
        "versionControl",
    ]

    def __init__(
        self,
        familyId,
        members,
        readyForAnalysis,
        LDPCode=None,
        analysisPanels=None,
        diseasePenetrances=None,
        familyQCState=None,
        versionControl=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.Pedigree model.

        :param familyId:
            Family identifier which internally translate to a sample set
        :type familyId: str
        :param members:
            List of members of a pedigree
        :type members: list[PedigreeMember]
        :param readyForAnalysis:
            Flag indicating if a pedigree is ready for analysis
        :type readyForAnalysis: boolean
        :param LDPCode:
            LDP Code (Local Delivery Partner)
        :type LDPCode: None | str
        :param analysisPanels:
            List of panels
        :type analysisPanels: None | list[AnalysisPanel]
        :param diseasePenetrances:
            List of disease penetrances. Moved to referralTest for GMS
        :type diseasePenetrances: None | list[DiseasePenetrance]
        :param familyQCState:
            The family quality control status
        :type familyQCState: None | FamilyQCState
        :param versionControl:
            Model version number
        :type versionControl: None | VersionControl
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
